<!DOCTYPE html>
<html lang="en" th:lang="#{lang}" xmlns:th="http://www.thymeleaf.org">
<head>
    <!--CSS -->
    <link th:href="@{/webjars/dropzone/5.5.0/min/dropzone.min.css}" rel="stylesheet">

    <!--/*/ <th:block th:include="fragments/layout :: head">
        </th:block> /*/-->

    <!--SCRIPTS-->
    <script th:src="@{/webjars/dropzone/5.5.0/min/dropzone.min.js}"></script>
    <script th:src="@{/js/ckeditor5/ckeditor.js}"></script>
    <script th:src="@{/js/ckeditor5/translations/cs.js}"></script>
</head>
<body>

<div id="wrapper">

    <div th:replace="fragments/layout :: header('admin')"></div>

    <!--CAROUSEL-->
    <!--<div th:replace="fragments/layout :: carousel-sm"></div>-->

    <main id="main" class="container mt-2">

        <div class="d-lg-flex">
            <div class="p-2">
                <!--BACK-->
                <div class="mb-2">
                    <a class="btn btn-sm btn-outline-secondary w-100" th:href="@{/admin/products}">
                        <i class="fas fa-chevron-left mr-2"></i>
                        Zpět na seznam
                    </a>
                </div>
                <!--SIDE NAV-->
                <div th:replace="fragments/layout :: adminSideNav('products')"></div>
            </div>

            <div class="flex-grow-1 p-2">
                <!--HEADING-->
                <div class="mb-3 pb-2 pt-1 border-bottom clearfix">
                    <h2 class="float-left" th:text="${product.name}">Produkt</h2>

                    <a class="btn btn-sm btn-danger float-right" th:href="@{/admin/product/remove/} + ${product.id}"
                       onclick="return confirm('Opravdu chcete smazat produkt?');">
                        <i class="fas fa-trash"></i>
                        Smazat produkt
                    </a>
                </div>

                <div id="errorMessage" class="alert alert-danger alert-dismissible" hidden role="alert">
                    <div id="errorText"></div>
                </div>

                <div th:replace="fragments/layout :: alerts"></div>

                <form id="product-form" class="dropzone needs-validation" method="post" enctype="multipart/form-data"
                      th:action="@{/admin/product/update}" th:object="${product}"
                      th:insert="product/productNew :: productEdit(${product})"
                      novalidate>
                </form>
            </div>
        </div>
    </main>
</div>

<!-- SPINNER -->
<div th:replace="fragments/layout :: spinner"></div>

<div th:replace="fragments/layout :: footer"></div>

<script th:inline="javascript">
    /*<![CDATA[*/

    $(document).ready(function () {

        /*[# th:each="image : ${product.images}"]*/

        var mockFile = {name: /*[[${image.name}]]*/ '', size: 13245};
        addFileToDropZone(myDropzone, mockFile, '/image/' + /*[[${image.getThumbnailName()}]]*/ '');

        /*[/]*/

        var items = $('.dz-preview');
        items.each(function (index) {
            var fileName = $(this).find('.dz-filename span')[0].innerHTML;
            if (fileName === /*[[${product.mainImageName}]]*/ '') {
                //$(this).addClass("active");
                changeActiveImage(this);
                //$('#hdnImgIndex').val(index);
            }
            $(this).addClass("saved");
        });

        $('.dz-remove').click(function () {
            var actPrev = $('.dz-preview.active');
            if (actPrev === null || actPrev.length === 0) {
                //byl smazán aktivní obrázek - musíme nastavit jiný
                var prevs = $('.dz-preview');
                if (prevs !== null && prevs.length > 0) {
                    //var item = prevs.eq(0);
                    //item.addClass("active");
                    changeActiveImage(prevs.eq(0));
                }
            }
        });

    });

    var myDropzone;

    Dropzone.options.productForm = { //imagesDiv, productForm
        paramName: 'files',
        url: '/admin/product/update',
        autoProcessQueue: false,
        uploadMultiple: true,
        parallelUploads: 100,
        maxFiles: 100,
        acceptedFiles: 'image/*',
        addRemoveLinks: true,
        previewsContainer: "#previews",
        //Translate
        dictRemoveFile: 'Smazat',

        // The setting up of the dropzone
        init: function () {
            myDropzone = this;

            // First change the button to actually tell Dropzone to process the queue.
            document.getElementById('submitBtnSave').addEventListener("click", function (e) {
                fillHdnSavedImages();
                document.getElementById('hiddenType').value = 'save';
                formSubmit(myDropzone, '/admin/product/update');
            });

            // First change the button to actually tell Dropzone to process the queue.
            document.getElementById('submitBtnNext').addEventListener("click", function (e) {
                // Make sure that the form isn't actually being sent.
                /*e.preventDefault();
                e.stopPropagation();*/

                fillHdnSavedImages();
                document.getElementById('hiddenType').value = 'next';
                formSubmit(myDropzone, '/admin/product/update');
            });

            myDropzone.on("addedfile", function (file) {

                //první obrázek se zvolí jako aktivní - hlavní obrázek
                var items = $('.dz-preview');
                if (items.length === 1) {
                    items.eq(0).addClass("active");
                }
            });

            // Listen to the sendingmultiple event. In this case, it's the sendingmultiple event instead
            // of the sending event because uploadMultiple is set to true.
            this.on("sendingmultiple", function () {
                // Gets triggered when the form is actually being sent.
                // Hide the success button or the complete form.
            });
            this.on("successmultiple", function (files, response) {
                // Gets triggered when the files have successfully been sent.
                // Redirect user or notify of success.

                responseFunc(response);
            });
            this.on("errormultiple", function (files, response) {
                // Gets triggered when there was an error sending the files.
                // Maybe show form again, and notify user of error
            });
        }
    };

    function fillHdnSavedImages() {
        var imgString = '';
        var prevItems = $('.dz-preview.saved');
        prevItems.each(function (index) {
            var fileName = $(this).find('.dz-filename span')[0].innerHTML;
            if (index > 0)
                imgString += ";";
            imgString += fileName;
        });
        $('#hdnSavedImages').val(imgString);
    }

    /*]]>*/
</script>

</body>
</html>